var fs = require('fs');
var path = require('path');
var rootdir = process.argv[2];

console.log("res_colleague rootdir " + rootdir)

//if (rootdir && process.argv[4] === 'cordova-plugin-colleague') {
if (rootdir && process.argv[4].toLowerCase().indexOf("colleague") !== -1) {

    try {
        //替换build.gradle文件内容
        var resGradlePath = path.join(rootdir, '../platforms/android/build.gradle');
        if (fs.existsSync(resGradlePath)) {
            replace_string_in_file(resGradlePath, "res.srcDirs = ['res']", "res.srcDir 'res'");
        } else {
            console.log("missing: " + resGradlePath);
        }
    } catch (e) {
        console.log(e)
    }

    /**MultiDex Change**/
    try {
        var manifestPath = path.join(rootdir, '../platforms/android/AndroidManifest.xml');
        //判断AndroidManifest.xml文件是否存在
        if (fs.existsSync(manifestPath)) {
            var data2 = fs.readFileSync(manifestPath, 'utf8');
            if (data2.indexOf("multidex") === -1) {
                replace_string_in_file(manifestPath, "<application", '<application android:name="android.support.multidex.MultiDexApplication"  android:theme="@style/Theme.AppCompat.Light.NoActionBar"');
            } else {
                console.log("manifest multidex application had init ");
            }
        } else {
            console.log("missing: " + manifestPath);
        }
        //替换build.gradle文件内容
        var gradlePath = path.join(rootdir, '../platforms/android/build.gradle');
        if (fs.existsSync(gradlePath)) {
            var data = fs.readFileSync(gradlePath, 'utf8');
            if (data.indexOf("multidex") === -1) {
                replace_string_in_file(gradlePath, /defaultConfig\s*\{/gi, 'defaultConfig {\n multiDexEnabled true');
                replace_string_in_file(gradlePath, /}\s*dependencies\s*\{/gi, '}\n dependencies {\n compile "com.android.support:multidex:1.0.0"');
            } else {
                console.log("multidex had init ");
            }
        } else {
            console.log("missing: " + gradlePath);
        }

    } catch (e) {
        process.stdout.write(e);
    }


    createConfig();

    function createConfig() {
        try {
            var configDir = path.join(rootdir, '../config');

            if (fs.existsSync(configDir)) {
                console.log("res_colleague configDir dirs exits")
            } else {
                fs.mkdirSync(configDir)
                console.log("res_colleague configDir dirs create")
            }

            var litePalPath = path.join(configDir, '/litepal.xml');
            var source = path.join(rootdir, '../plugins/cordova-plugin-colleague/src/android/xml/litepal.xml');
            console.log("res_colleague litepal source path " + source)
            console.log("res_colleague litepal dirs path " + litePalPath)
            if (fs.existsSync(litePalPath)) {
                console.log("res_colleague litepal dirs exits")
            } else {
                copy(source , litePalPath)
                console.log("litePalPath litepal dirs copy")
            }


            var fulldbPath = path.join(configDir, '/locations.db');
            var sourcebd = path.join(rootdir, '../plugins/cordova-plugin-colleague/src/android/db/locations.db');
            console.log("res_colleague config db source path " + sourcebd)
            console.log("res_colleague config db dirs path " + fulldbPath)
            if (fs.existsSync(fulldbPath)) {
                console.log("res_colleague config db dirs exits")
            } else {
                copy(sourcebd , fulldbPath)
                console.log("res_colleague config db dirs copy")
            }

            var fullRawPath = path.join(configDir, '/expression_config.xml');
            var sourceRaw = path.join(rootdir, '../plugins/cordova-plugin-colleague/src/android/xml/expression_config.xml');

            console.log("res_colleague config raw source path " + sourceRaw)
            console.log("res_colleague config raw dirs path " + fullRawPath)
            if (fs.existsSync(fullRawPath)) {
                console.log("res_colleague config raw dirs exits")
            } else {
                copy(sourceRaw , fullRawPath)
                console.log("fullfilenPath config raw dirs copy")
            }


            var fullConfigPath = path.join(configDir, '/config.xml');
            var sourceConfig = path.join(rootdir, '../plugins/cordova-plugin-colleague/src/android/xml/config.xml');
            console.log("res_colleague config.xml  source path " + sourceConfig)
            console.log("res_colleague config.xml  dirs path " + fullConfigPath)
            if (fs.existsSync(fullConfigPath)) {
                console.log("res_colleague config.xml  dirs exits")
            } else {
                copy(sourceConfig, fullConfigPath)
                console.log("res_colleague config.xml  dirs copy")
            }

            var fullProviderPath = path.join(configDir, '/provider_file.xml');
            var sourceProvider = path.join(rootdir, '../plugins/cordova-plugin-colleague/src/android/xml/provider_file.xml');
            console.log("res_colleague provider_file.xml  source path " + sourceProvider)
            console.log("res_colleague provider_file.xml  dirs path " + fullProviderPath)
            if (fs.existsSync(fullProviderPath)) {
                console.log("res_colleague provider_file.xml  dirs exits")
            } else {
                copy(sourceProvider, fullProviderPath)
                console.log("res_colleague provider_file.xml  dirs copy")
            }


        } catch (e) {
            console.log(e)
        }
    }


    function copy(src, dst) {
        fs.writeFileSync(dst, fs.readFileSync(src));
    }

    //正则表达式替换文本
    function replace_string_in_file(filename, to_replace, replace_with) {
        var data = fs.readFileSync(filename, 'utf8');
        console.log(to_replace)
        console.log(replace_with)
        var result = data.replace(to_replace, replace_with);
        fs.writeFileSync(filename, result, 'utf8');
    }
}

