var fs = require('fs');
var path = require('path');
var rootdir = process.argv[2];

console.log("res_colleague move config " + rootdir)

if (rootdir) {

    moveConfig();

    function moveConfig() {
        try {
            var litePalPath = path.join(rootdir, '../platforms/android/assets/litepal.xml');
            var source = path.join(rootdir, '../config/litepal.xml');
            console.log("res_colleague litepal source path " + source)
            console.log("res_colleague litepal dirs path " + litePalPath)
            if (fs.existsSync(litePalPath)) {
                console.log("res_colleague litepal dirs exits")
                if(!compareFile(source, litePalPath)) {
                    fs.unlinkSync(source);
                    console.log("raw litepal changed copy")
                    copy(source , litePalPath)
                }
            } else {
                copy(source , litePalPath)
                console.log("litePalPath litepal dirs copy")
            }


            var providerPath = path.join(rootdir, '../platforms/android/res/xml/provider_file.xml');
            var providerSource = path.join(rootdir, '../config/provider_file.xml');
            console.log("res_colleague providerPath source path " + providerSource)
            console.log("res_colleague providerPath dirs path " + providerPath)
            if (fs.existsSync(providerPath)) {
                console.log("providerPath dirs exits")
                if(!compareFile(providerSource, providerPath)) {
                    fs.unlinkSync(source);
                    console.log("providerPath changed copy")
                    copy(providerSource , providerPath)
                }
            } else {
                copy(providerSource , providerPath)
                console.log("providerPath litepal dirs copy")
            }



            var fulldbPath = path.join(rootdir, '../platforms/android/assets/db/locations.db');
            var fulldbPathDir = path.join(rootdir, '../platforms/android/assets/db');

            var sourcebd = path.join(rootdir, '../config/locations.db');
            console.log("res_colleague db source path " + sourcebd)
            console.log("res_colleague db dirs path " + fulldbPath)
            if (fs.existsSync(fulldbPath)) {
                console.log("res_colleague db dirs exits")
                if(!compareFile(sourcebd, fulldbPath)) {
                    fs.unlinkSync(sourcebd);
                    console.log("raw db changed copy")
                    copy(sourcebd , fulldbPath)
                }
            } else {
                if (!fs.existsSync(fulldbPathDir)) {
                    fs.mkdirSync(fulldbPathDir)
                }
                copy(sourcebd , fulldbPath)
                console.log("fullfilenPath db dirs copy")
            }

            var fullRawPath = path.join(rootdir, '../platforms/android/res/raw/expression_config.xml');
            var fullRawPathDir = path.join(rootdir, '../platforms/android/res/raw');
            var sourceRaw = path.join(rootdir, '../config/expression_config.xml');

            console.log("res_colleague raw source path " + sourceRaw)
            console.log("res_colleague raw dirs path " + fullRawPath)
            if (fs.existsSync(fullRawPath)) {
                console.log("res_colleague raw dirs exits")
                if(!compareFile(sourceRaw, fullRawPath)) {
                    fs.unlinkSync(fullRawPath);
                    console.log("raw dirs changed copy")
                    copy(sourceRaw , fullRawPath)
                }
            } else {
                if (!fs.existsSync(fullRawPathDir)) {
                    fs.mkdirSync(fullRawPathDir)
                }
                copy(sourceRaw , fullRawPath)
                console.log("fullfilenPath raw dirs copy")
            }

            var fullConfigPath = path.join(rootdir, '../platforms/android/res/raw/config.xml');
            var fullConfigPathDir = path.join(rootdir, '../platforms/android/res/raw');
            var sourceConfig = path.join(rootdir, '../config/config.xml');

            console.log("res_colleague raw source path " + sourceConfig)
            console.log("res_colleague raw dirs path " + fullConfigPath)
            if (fs.existsSync(fullConfigPath)) {
                console.log("res_colleague config.xml dirs exits")
                if(!compareFile(sourceConfig, fullConfigPath)) {
                    fs.unlinkSync(fullConfigPath);
                    console.log("config.xml dirs changed copy")
                    copy(sourceConfig , fullConfigPath)
                }
            } else {
                if (!fs.existsSync(fullConfigPathDir)) {
                    fs.mkdirSync(fullConfigPathDir)
                }
                copy(sourceConfig , fullConfigPath)
                console.log("res_colleague config.xml dirs copy")
            }


        } catch (e) {
            console.log(e)
        }
    }


    function copy(src, dst) {
        fs.writeFileSync(dst, fs.readFileSync(src));
    }

    //正则表达式替换文本
    function compareFile(source, target) {
        var sourceData = fs.readFileSync(source, 'utf8');
        var targetData = fs.readFileSync(target, 'utf8');
        if (sourceData == targetData) {
            console.log("compareFile not change")
            return true
        }
        console.log("compareFile changed")
        return false
    }
}

